<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/SampleApp/Authorization/CBLAuthDelegate/include/CBLAuthDelegate/CBLAuthDelegate.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_69fa8d0f4fee2820ffc8601fbf428b42.html">SampleApp</a></li><li class="navelem"><a class="el" href="dir_cb95416188067ed3b93365313f46b1cf.html">Authorization</a></li><li class="navelem"><a class="el" href="dir_394d140097375e95b03f61a9aaebbe14.html">CBLAuthDelegate</a></li><li class="navelem"><a class="el" href="dir_9dd8d0f9a49957230a9490745c7e4f43.html">include</a></li><li class="navelem"><a class="el" href="dir_be1d93f3c47bfa6e8af1e657ecd75a30.html">CBLAuthDelegate</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">CBLAuthDelegate.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_c_b_l_auth_delegate_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_SAMPLEAPP_AUTHORIZATION_CBLAUTHDELEGATE_INCLUDE_CBLAUTHDELEGATE_CBLAUTHDELEGATE_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_SAMPLEAPP_AUTHORIZATION_CBLAUTHDELEGATE_INCLUDE_CBLAUTHDELEGATE_CBLAUTHDELEGATE_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;condition_variable&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;unordered_set&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_auth_delegate_interface_8h.html">AVSCommon/SDKInterfaces/AuthDelegateInterface.h</a>&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_auth_observer_interface_8h.html">AVSCommon/SDKInterfaces/AuthObserverInterface.h</a>&gt;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_configuration_node_8h.html">AVSCommon/Utils/Configuration/ConfigurationNode.h</a>&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_http_post_interface_8h.html">AVSCommon/Utils/LibcurlUtils/HttpPostInterface.h</a>&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_device_info_8h.html">AVSCommon/Utils/DeviceInfo.h</a>&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_retry_timer_8h.html">AVSCommon/Utils/RetryTimer.h</a>&gt;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_customer_data_handler_8h.html">RegistrationManager/CustomerDataHandler.h</a>&gt;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_c_b_l_auth_delegate_configuration_8h.html">CBLAuthDelegate/CBLAuthDelegateConfiguration.h</a>&quot;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_c_b_l_auth_delegate_storage_interface_8h.html">CBLAuthDelegate/CBLAuthDelegateStorageInterface.h</a>&quot;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_c_b_l_auth_requester_interface_8h.html">CBLAuthDelegate/CBLAuthRequesterInterface.h</a>&quot;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1authorization.html">   40</a></span>&#160;<span class="keyword">namespace </span>authorization {</div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate.html">   41</a></span>&#160;<span class="keyword">namespace </span>cblAuthDelegate {</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">   48</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html">avsCommon::sdkInterfaces::AuthDelegateInterface</a></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html">registrationManager::CustomerDataHandler</a> {</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">static</span> std::unique_ptr&lt;CBLAuthDelegate&gt; <a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a35a3aab6219b7d1d3ffa50b21726a3e7">create</a>(</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">avsCommon::utils::configuration::ConfigurationNode</a>&amp; configuration,</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        std::shared_ptr&lt;registrationManager::CustomerDataManager&gt; customerDataManager,</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        std::shared_ptr&lt;CBLAuthDelegateStorageInterface&gt; storage,</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        std::shared_ptr&lt;CBLAuthRequesterInterface&gt; authRequester,</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        std::shared_ptr&lt;avsCommon::utils::libcurlUtils::HttpPostInterface&gt; httpPost = <span class="keyword">nullptr</span>,</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        std::shared_ptr&lt;avsCommon::utils::DeviceInfo&gt; deviceInfo = <span class="keyword">nullptr</span>);</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a8d7b8505de39a1008ade4a3ef4bec812">CBLAuthDelegate</a>(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a>&amp; rhs) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#af91fa3fcdfebc49c0c4fbc192d1fa5d7">~CBLAuthDelegate</a>();</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a>&amp; <a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#ae1f95c62962c04b103c3b832f3dd51e8">operator=</a>(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">CBLAuthDelegate</a>&amp; rhs) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#ae3b4c2dbdbc2bbb4ce098faa4f92fdc5">addAuthObserver</a>(std::shared_ptr&lt;avsCommon::sdkInterfaces::AuthObserverInterface&gt; observer) <span class="keyword">override</span>;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#ad9c4e36ecd1310564e2bcb0950e52b52">removeAuthObserver</a>(std::shared_ptr&lt;avsCommon::sdkInterfaces::AuthObserverInterface&gt; observer) <span class="keyword">override</span>;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    std::string <a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a6090364bb64d10192a562c93fb0a823d">getAuthToken</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a633e5f9dd987fac530edf5fbb443ec3f">onAuthFailure</a>(<span class="keyword">const</span> std::string&amp; token) <span class="keyword">override</span>;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#acde6f10ba3fb25419f66fdc7927c9bc0">clearData</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keyword">enum class</span> FlowState {</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        STARTING,</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        REQUESTING_CODE_PAIR,</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        REQUESTING_TOKEN,</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        REFRESHING_TOKEN,</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        STOPPING</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    };</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a8d7b8505de39a1008ade4a3ef4bec812">CBLAuthDelegate</a>(</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        std::shared_ptr&lt;registrationManager::CustomerDataManager&gt; customerDataManager,</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        std::shared_ptr&lt;CBLAuthDelegateStorageInterface&gt; storage,</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        std::shared_ptr&lt;CBLAuthRequesterInterface&gt; authRequester,</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        std::shared_ptr&lt;avsCommon::utils::libcurlUtils::HttpPostInterface&gt; httpPost);</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <span class="keywordtype">bool</span> init(</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">avsCommon::utils::configuration::ConfigurationNode</a>&amp; configuration,</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        <span class="keyword">const</span> std::shared_ptr&lt;avsCommon::utils::DeviceInfo&gt;&amp; deviceInfo);</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    <span class="keywordtype">void</span> stop();</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keywordtype">void</span> handleAuthorizationFlow();</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    FlowState handleStarting();</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    FlowState handleRequestingCodePair();</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    FlowState handleRequestingToken();</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    FlowState handleRefreshingToken();</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    FlowState handleStopping();</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_h_t_t_p_response.html">avsCommon::utils::libcurlUtils::HTTPResponse</a> requestCodePair();</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_h_t_t_p_response.html">avsCommon::utils::libcurlUtils::HTTPResponse</a> requestToken();</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_h_t_t_p_response.html">avsCommon::utils::libcurlUtils::HTTPResponse</a> requestRefresh();</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html#a3a3b2f95459c18e64fab7a296ad9fbce">avsCommon::sdkInterfaces::AuthObserverInterface::Error</a> receiveCodePairResponse(</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        <span class="keyword">const</span> <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_h_t_t_p_response.html">avsCommon::utils::libcurlUtils::HTTPResponse</a>&amp; response);</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html#a3a3b2f95459c18e64fab7a296ad9fbce">avsCommon::sdkInterfaces::AuthObserverInterface::Error</a> receiveTokenResponse(</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        <span class="keyword">const</span> <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_h_t_t_p_response.html">avsCommon::utils::libcurlUtils::HTTPResponse</a>&amp; response,</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        <span class="keywordtype">bool</span> expiresImmediately);</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;    <span class="keywordtype">void</span> setAuthState(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html#a62a72a6ac191b845c9a379a7d4ad56f4">avsCommon::sdkInterfaces::AuthObserverInterface::State</a> newState);</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    <span class="keywordtype">void</span> setAuthError(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html#a3a3b2f95459c18e64fab7a296ad9fbce">avsCommon::sdkInterfaces::AuthObserverInterface::Error</a> error);</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    <span class="keywordtype">void</span> setRefreshToken(<span class="keyword">const</span> std::string&amp; refreshToken);</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    <span class="keywordtype">void</span> clearRefreshToken();</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    <span class="keywordtype">bool</span> isStopping();</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    std::shared_ptr&lt;CBLAuthDelegateStorageInterface&gt; m_storage;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    std::shared_ptr&lt;avsCommon::utils::libcurlUtils::HttpPostInterface&gt; m_httpPost;</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;    std::shared_ptr&lt;CBLAuthRequesterInterface&gt; m_authRequester;</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;    std::unique_ptr&lt;CBLAuthDelegateConfiguration&gt; m_configuration;</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;    <span class="keywordtype">bool</span> m_isStopping;</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    std::mutex m_mutex;</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;    std::unordered_set&lt;std::shared_ptr&lt;avsCommon::sdkInterfaces::AuthObserverInterface&gt;&gt; m_observers;</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;    std::string m_accessToken;</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html#a62a72a6ac191b845c9a379a7d4ad56f4">avsCommon::sdkInterfaces::AuthObserverInterface::State</a> m_authState;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html#a3a3b2f95459c18e64fab7a296ad9fbce">avsCommon::sdkInterfaces::AuthObserverInterface::Error</a> m_authError;</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;    std::string m_deviceCode;</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    std::string m_userCode;</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;    std::thread m_authorizationFlowThread;</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;    std::chrono::steady_clock::time_point m_codePairExpirationTime;</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;    std::chrono::steady_clock::time_point m_tokenExpirationTime;</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;    std::string m_refreshToken;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;    std::condition_variable m_wake;</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;    std::chrono::steady_clock::time_point m_timeToRefresh;</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;    std::chrono::steady_clock::time_point m_requestTime;</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;    <span class="keywordtype">int</span> m_retryCount;</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    <span class="keywordtype">bool</span> m_newRefreshToken;</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;    <span class="keywordtype">bool</span> m_authFailureReported;</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;};</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;}  <span class="comment">// namespace cblAuthDelegate</span></div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;}  <span class="comment">// namespace authorization</span></div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_SAMPLEAPP_AUTHORIZATION_CBLAUTHDELEGATE_INCLUDE_CBLAUTHDELEGATE_CBLAUTHDELEGATE_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">alexaClientSDK::avsCommon::utils::configuration::ConfigurationNode</a></div><div class="ttdef"><b>Definition:</b> ConfigurationNode.h:70</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_html_a6090364bb64d10192a562c93fb0a823d"><div class="ttname"><a href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a6090364bb64d10192a562c93fb0a823d">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::getAuthToken</a></div><div class="ttdeci">std::string getAuthToken() override</div><div class="ttdef"><b>Definition:</b> CBLAuthDelegate.cpp:349</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_html_a633e5f9dd987fac530edf5fbb443ec3f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a633e5f9dd987fac530edf5fbb443ec3f">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::onAuthFailure</a></div><div class="ttdeci">void onAuthFailure(const std::string &amp;token) override</div><div class="ttdef"><b>Definition:</b> CBLAuthDelegate.cpp:354</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_html_ae3b4c2dbdbc2bbb4ce098faa4f92fdc5"><div class="ttname"><a href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#ae3b4c2dbdbc2bbb4ce098faa4f92fdc5">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::addAuthObserver</a></div><div class="ttdeci">void addAuthObserver(std::shared_ptr&lt; avsCommon::sdkInterfaces::AuthObserverInterface &gt; observer) override</div><div class="ttdef"><b>Definition:</b> CBLAuthDelegate.cpp:323</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate</a></div><div class="ttdef"><b>Definition:</b> CBLAuthDelegate.h:48</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_html_a8d7b8505de39a1008ade4a3ef4bec812"><div class="ttname"><a href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a8d7b8505de39a1008ade4a3ef4bec812">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::CBLAuthDelegate</a></div><div class="ttdeci">CBLAuthDelegate(const CBLAuthDelegate &amp;rhs)=delete</div></div>
<div class="ttc" id="_device_info_8h_html"><div class="ttname"><a href="_device_info_8h.html">DeviceInfo.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface_html_a62a72a6ac191b845c9a379a7d4ad56f4"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html#a62a72a6ac191b845c9a379a7d4ad56f4">alexaClientSDK::avsCommon::sdkInterfaces::AuthObserverInterface::State</a></div><div class="ttdeci">State</div><div class="ttdoc">The enum State describes the state of authorization. </div><div class="ttdef"><b>Definition:</b> AuthObserverInterface.h:34</div></div>
<div class="ttc" id="_auth_observer_interface_8h_html"><div class="ttname"><a href="_auth_observer_interface_8h.html">AuthObserverInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_html_ae1f95c62962c04b103c3b832f3dd51e8"><div class="ttname"><a href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#ae1f95c62962c04b103c3b832f3dd51e8">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::operator=</a></div><div class="ttdeci">CBLAuthDelegate &amp; operator=(const CBLAuthDelegate &amp;rhs)=delete</div></div>
<div class="ttc" id="_c_b_l_auth_delegate_configuration_8h_html"><div class="ttname"><a href="_c_b_l_auth_delegate_configuration_8h.html">CBLAuthDelegateConfiguration.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_html_a35a3aab6219b7d1d3ffa50b21726a3e7"><div class="ttname"><a href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a35a3aab6219b7d1d3ffa50b21726a3e7">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::create</a></div><div class="ttdeci">static std::unique_ptr&lt; CBLAuthDelegate &gt; create(const avsCommon::utils::configuration::ConfigurationNode &amp;configuration, std::shared_ptr&lt; registrationManager::CustomerDataManager &gt; customerDataManager, std::shared_ptr&lt; CBLAuthDelegateStorageInterface &gt; storage, std::shared_ptr&lt; CBLAuthRequesterInterface &gt; authRequester, std::shared_ptr&lt; avsCommon::utils::libcurlUtils::HttpPostInterface &gt; httpPost=nullptr, std::shared_ptr&lt; avsCommon::utils::DeviceInfo &gt; deviceInfo=nullptr)</div><div class="ttdef"><b>Definition:</b> CBLAuthDelegate.cpp:270</div></div>
<div class="ttc" id="_http_post_interface_8h_html"><div class="ttname"><a href="_http_post_interface_8h.html">HttpPostInterface.h</a></div></div>
<div class="ttc" id="_configuration_node_8h_html"><div class="ttname"><a href="_configuration_node_8h.html">ConfigurationNode.h</a></div></div>
<div class="ttc" id="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_h_t_t_p_response_html"><div class="ttname"><a href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_h_t_t_p_response.html">alexaClientSDK::avsCommon::utils::libcurlUtils::HTTPResponse</a></div><div class="ttdef"><b>Definition:</b> HTTPResponse.h:29</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface</a></div><div class="ttdef"><b>Definition:</b> AuthDelegateInterface.h:40</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface_html_a3a3b2f95459c18e64fab7a296ad9fbce"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html#a3a3b2f95459c18e64fab7a296ad9fbce">alexaClientSDK::avsCommon::sdkInterfaces::AuthObserverInterface::Error</a></div><div class="ttdeci">Error</div><div class="ttdoc">The enum Error encodes possible errors which may occur when changing state. </div><div class="ttdef"><b>Definition:</b> AuthObserverInterface.h:46</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_html_ad9c4e36ecd1310564e2bcb0950e52b52"><div class="ttname"><a href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#ad9c4e36ecd1310564e2bcb0950e52b52">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::removeAuthObserver</a></div><div class="ttdeci">void removeAuthObserver(std::shared_ptr&lt; avsCommon::sdkInterfaces::AuthObserverInterface &gt; observer) override</div><div class="ttdef"><b>Definition:</b> CBLAuthDelegate.cpp:338</div></div>
<div class="ttc" id="_customer_data_handler_8h_html"><div class="ttname"><a href="_customer_data_handler_8h.html">CustomerDataHandler.h</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_html_af91fa3fcdfebc49c0c4fbc192d1fa5d7"><div class="ttname"><a href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#af91fa3fcdfebc49c0c4fbc192d1fa5d7">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::~CBLAuthDelegate</a></div><div class="ttdeci">~CBLAuthDelegate()</div><div class="ttdef"><b>Definition:</b> CBLAuthDelegate.cpp:319</div></div>
<div class="ttc" id="_c_b_l_auth_delegate_storage_interface_8h_html"><div class="ttname"><a href="_c_b_l_auth_delegate_storage_interface_8h.html">CBLAuthDelegateStorageInterface.h</a></div></div>
<div class="ttc" id="_retry_timer_8h_html"><div class="ttname"><a href="_retry_timer_8h.html">RetryTimer.h</a></div></div>
<div class="ttc" id="_auth_delegate_interface_8h_html"><div class="ttname"><a href="_auth_delegate_interface_8h.html">AuthDelegateInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html">alexaClientSDK::registrationManager::CustomerDataHandler</a></div><div class="ttdef"><b>Definition:</b> CustomerDataHandler.h:33</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate_html_acde6f10ba3fb25419f66fdc7927c9bc0"><div class="ttname"><a href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#acde6f10ba3fb25419f66fdc7927c9bc0">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate::clearData</a></div><div class="ttdeci">void clearData() override</div><div class="ttdef"><b>Definition:</b> CBLAuthDelegate.cpp:365</div></div>
<div class="ttc" id="_c_b_l_auth_requester_interface_8h_html"><div class="ttname"><a href="_c_b_l_auth_requester_interface_8h.html">CBLAuthRequesterInterface.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
